#include <sys/syslog.h>

#include "logger.h"

void Logger::init()
{
    openlog("linutop-kiosk", 0, LOG_LOCAL0);
}

void Logger::shutdown()
{
    closelog();
}

void Logger::logInfo(QString &msg)
{
    syslog(LOG_INFO, "%s", msg.toUtf8().data());
}

void Logger::logInfo(const char *msg)
{
    syslog(LOG_INFO, "%s", msg);
}


void Logger::logWarning(QString &msg)
{
    syslog(LOG_WARNING, "%s", msg.toUtf8().data());
}

void Logger::logWarning(const char *msg)
{
    syslog(LOG_WARNING, "%s", msg);
}


void Logger::logError(QString &msg)
{
    syslog(LOG_ERR, "%s", msg.toUtf8().data());
}

void Logger::logError(const char *msg)
{
    syslog(LOG_ERR, "%s", msg);
}
