#ifndef SYSTEMPANEL_H
#define SYSTEMPANEL_H

/** @brief Manage panel hidding during the application.
 *
 *  Webkiosk security feature.
 */
namespace panel {

class LXDE;
class XFCE;

/**
 * @brief Parent class for panel hidding management.
 */
class Manager {
public:

    virtual ~Manager(void) {}

    /**
     * @brief RAII model for panel management.
     * @param fullscreen Is the application in fullscreen ?
     * @return A pointer to the appropriate class.
     *
     * This create the good manager following the current Window Manager.
     */
    static Manager* create(bool fullscreen, bool use_password);

    bool is_fullscreen(void) const;
    bool use_password(void) const;

protected:

    Manager(bool fullscreen, bool use_password);

private:

    bool m_fullscreen;
    bool m_use_password;
};

} // panel


#endif // SYSTEMPANEL_H
