#ifndef SYSTEMUSBAUTO_H
#define SYSTEMUSBAUTO_H

#include <QObject>
#include <QDBusMessage>
#include <QScopedPointer>


class QDBusMessage;
class QDBusInterface;
class WindowManagerKiller;

class UsbAuto : public QObject
{
    Q_OBJECT

public:
    UsbAuto(QString const& remoteKey);
    virtual ~UsbAuto(void);

Q_SIGNALS:

    void usbCopyDone(QString dir);
    void finished(void);

private Q_SLOTS:

    void onUsbKeyMounted(QDBusMessage message);
    void onUsbKeyPlugged(QDBusMessage message);
    void copyFiles(void);

private:

    QString m_key;
    QString m_device;
    QString m_uuid;
    bool m_active;
    QScopedPointer<WindowManagerKiller> m_killer;
};

#endif // SYSTEMUSBAUTO_H
