#include "windowmanagerkiller.h"

#include <QProcess>
#include <QDebug>


WindowManagerKiller::WindowManagerKiller(void)
{ qDebug() << "Create window manager killer."; }


WindowManagerKiller::~WindowManagerKiller(void)
{ qDebug() << "Destroy window manager killer."; }


class ThunarKiller : public WindowManagerKiller
{
public:

    ThunarKiller(void)
    {
        QProcess k;
        k.start("killall", QStringList() << "Thunar");
        k.waitForFinished();
        qDebug() << "Thunar killed.";
    }

    virtual ~ThunarKiller(void)
    {
        QProcess k;
        k.startDetached("Thunar", QStringList() << "--daemon");
        qDebug() << "Thunar restarted.";
    }
};

class PCManFMKiller : public WindowManagerKiller
{
public:

    PCManFMKiller(void)
    {
        QProcess k;
        k.start("killall", QStringList() << "pcmanfm");
        k.waitForFinished();
        qDebug() << "Pcmanfm killed.";
    }

    virtual ~PCManFMKiller(void)
    {
        QProcess k;
        k.startDetached("pcmanfm", QStringList() << "--daemon-mode");
        qDebug() << "Pcmanfm restarted.";
    }
};


WindowManagerKiller *WindowManagerKiller::create(void)
{
    // Test if Thunar.
    {
        QProcess thunar;
        thunar.start("pgrep", QStringList() << "Thunar");
        thunar.waitForFinished();
        QByteArray result = thunar.readAllStandardOutput();
        if (result.size() != 0) return new ThunarKiller;
    }

    // Test if PCManFM.
    {
        QProcess pcmanfm;
        pcmanfm.start("pgrep", QStringList() << "pcmanfm");
        pcmanfm.waitForFinished();
        QByteArray result = pcmanfm.readAllStandardOutput();
        if (result.size() != 0) return new PCManFMKiller;
    }

    // Else return empty.
    return new WindowManagerKiller;
}

