#include <QLineEdit>

#include "exitpassworddialog.h"

ExitPasswordDialog::ExitPasswordDialog (QWidget *parent)
    : QInputDialog (parent)
{
    setWindowTitle ("Password Required");
    setLabelText ("Administrator password:");
    setTextEchoMode (QLineEdit::Password);

    setMouseTracking (true);
    evf = new ExitPasswordDialogEventFilter (this);
    installEventFilter (evf);

    connect (&timer, SIGNAL(timeout()), this, SLOT(onTimeout()));
}

ExitPasswordDialog::~ExitPasswordDialog ()
{
    timer.stop();
}

QString ExitPasswordDialog::run ()
{
    timer.start (10000);
    if (exec ())
        return textValue();
    else
        return QString();
}

void ExitPasswordDialog::onTimeout ()
{
    close();
    deleteLater();
}

void ExitPasswordDialog::resetTimer ()
{
    timer.start ();
}
