#ifndef EXITPASSWORDDIALOG_H
#define EXITPASSWORDDIALOG_H

#include <QInputDialog>
#include <QTimer>
#include <QEvent>
#include <QMouseEvent>
#include <QInputEvent>

#include <QDebug>

class ExitPasswordDialogEventFilter;

class ExitPasswordDialog : public QInputDialog
{
    friend class ExitPasswordDialogEventFilter;

    Q_OBJECT

public:
    ExitPasswordDialog (QWidget *parent = 0);
    ~ExitPasswordDialog ();
    QString run ();

private:
    void resetTimer ();
    void onTimeout ();

    QTimer timer;
    ExitPasswordDialogEventFilter *evf;
};

class ExitPasswordDialogEventFilter : public QObject
{
    Q_OBJECT

public:
    ExitPasswordDialogEventFilter (QObject *parent = 0)
        : QObject (parent) {};

protected:
    bool eventFilter (QObject *obj, QEvent *event)
    {
        if ((dynamic_cast<QMouseEvent *>(event) != NULL) ||
            (dynamic_cast<QInputEvent *>(event) != NULL))
        {
            dynamic_cast<ExitPasswordDialog *>(obj)->resetTimer ();
        }

        return false;
    };
};

#endif
