#include <QPalette>
#include <QLinearGradient>
#include <QApplication>

#include "locationedit.h"

void LocationEdit::paintEvent (QPaintEvent *event)
{
    QPalette palette;
    QColor defaultBaseColor = QApplication::palette().color(QPalette::Base);
    QColor backgroundColor = defaultBaseColor;

    if (progress == 0 || progress == 100)
        palette.setBrush (QPalette::Base, backgroundColor);
    else
    {
        QColor loadingColor (116, 192, 250);
        if (palette.color (QPalette::Text).value() > 128)
            loadingColor = defaultBaseColor.darker (200);
        QLinearGradient gradient (0, 0, width(), 0);
        gradient.setColorAt (0, loadingColor);
        gradient.setColorAt (progress/100.0, backgroundColor);
        palette.setBrush (QPalette::Base, gradient);
    }
    setPalette (palette);

    QLineEdit::paintEvent (event);
}

void LocationEdit::setProgress (int p)
{
    progress = p;
    update();
}
