#ifndef NAVBAR_H
#define NAVBAR_H

#include <QToolBar>

#include "restrictedwebview.h"
#include "locationedit.h"
#include "settings.h"

class NavBar : public QToolBar
{
    Q_OBJECT

public:
    NavBar(RestrictedWebView *view, QWidget *parent = 0);
    LocationEdit *locationEdit() const { return m_locationEdit; };

Q_SIGNALS:
    void titleChanged(QString &);
    void printRequested();
    void end();

private Q_SLOTS:
    void adjustLocation(bool);
    void adjustTitle(const QString &);
    void setProgress(int i);
    void onGoHome();
    void setHistoryStatus();
    void onLocationChanged();
    void onPrint();
    void onEnd();

private:
    RestrictedWebView *m_view;
    LocationEdit *m_locationEdit;
    Settings *settings;
};

#endif
