#ifndef EXTERNALBROWSER_H
#define EXTERNALBROWSER_H


#include <QWidget>
#include <QProcess>

#include "runnable.h"
#include "playlistitem.h"

class ExternalBrowser : public QWidget, public Runnable
{
    Q_OBJECT

public:

    ExternalBrowser(PlaylistItem *item, QWidget *parent);

private:
    bool startImpl(void);
    bool stopImpl(void);
    bool onTimeoutImpl(void);
    void pauseImpl(void);
    void resumeImpl(void);

    void mousePressEvent(QMouseEvent*);
    QProcess player;
    QString m_uri;

Q_SIGNALS:
    void end();
    void rightclick();
    void middleclick(void);
    void leftclick(void);

private Q_SLOTS:
    void onMediaEndReached(int);
};

#endif // EXTERNALBROWSER_H
