#ifndef GIF_H
#define GIF_H

#include <QTimer>
#include <QWidget>
#include <QLabel>
#include <QProcess>
#include <QtWidgets>

#include "runnable.h"
#include "playlistitem.h"

class Gif : public QLabel, public Runnable
{
    Q_OBJECT
public:
    Gif(PlaylistItem *item, QWidget *parent);

private:
    bool startImpl(void);
    bool stopImpl(void);
    bool onTimeoutImpl(void);
    void pauseImpl(void);
    void resumeImpl(void);

    void setBlackBackground();
    void displayGif(void);
    void mousePressEvent(QMouseEvent*);

    QString m_uri;
    QString m_time;
    QMovie *movie;

Q_SIGNALS:
    void end();
    void rightclick();

};

#endif // GIF_H
