#ifndef PDF_H
#define PDF_H

#include <QLabel>
#include <QTimer>
#include <poppler-qt5.h>

#include "runnable.h"
#include "playlistitem.h"


class PDF : public QLabel, public Runnable
{
    Q_OBJECT

public:
    PDF(PlaylistItem *item, QWidget *parent);

private:
    QString m_uri;
    Poppler::Document* m_document;
    int m_pageNb;
    QPixmap m_pixmap;

    float p_w, p_h, s_w, s_h;

    bool startImpl(void);
    bool stopImpl(void);
    bool onTimeoutImpl(void);
    void pauseImpl(void);
    void resumeImpl(void);

    bool nextPage(void);

    void mousePressEvent(QMouseEvent*);
    void setBlackBackground(void);

Q_SIGNALS:
    void end(void);
    void rightclick(void);
};

#endif
