#ifndef _BROWSER_WIDGET_VIDEO_H_
#define _BROWSER_WIDGET_VIDEO_H_

#include <vlc/vlc.h>

#include <QTimer>
#include <QWidget>

#include "runnable.h"
#include "playlistitem.h"

class VideoImpl;

class Video : public QWidget, public Runnable
{
    Q_OBJECT

public:
    Video(PlaylistItem *item, QWidget *parent);
    virtual ~Video(void);

private:

    bool startImpl(void);
    bool stopImpl(void);
    bool onTimeoutImpl(void);
    void pauseImpl(void);
    void resumeImpl(void);

    void mousePressEvent(QMouseEvent*);

    friend class VideoImpl;
    VideoImpl* m_impl;

Q_SIGNALS:
    void end();
    void rightclick();
};

#endif // _BROWSER_WIDGET_VIDEO_H_
