#ifndef _BROWSER_WIDGETS_VIDEO_EXTERNALIMPL_H_
#define _BROWSER_WIDGETS_VIDEO_EXTERNALIMPL_H_

#include "./videoimpl.h"


class QProcess;

class ExternalVideoImpl
        : public QObject, public VideoImpl
{
    Q_OBJECT

public:

    ExternalVideoImpl(QStringList const& command, PlaylistItem* item, Video* p);

    ~ExternalVideoImpl(void);

    bool start(void);

    bool stop(void);

    bool onTimeout(void);

    void pause(void) {}

    void resume(void) {}

public Q_SLOTS:

    void onMediaEndReached(int);
    void readyReadStandardOutput(void);
    bool readyReadStandardError(void);

private:

    QStringList _command;
    QProcess* _process;
    void* _display;
    unsigned long _window;
};


#endif // _BROWSER_WIDGETS_VIDEO_EXTERNALIMPL_H_
