#ifndef _BROWSER_WIDGETS_VIDEO_VIDEOIMPL_H_
#define _BROWSER_WIDGETS_VIDEO_VIDEOIMPL_H_

#include "../video.h"
#include "settings.h"


class VideoImpl
{
public:

    VideoImpl(PlaylistItem* item, Video* parent)
        : m_parent(parent)
        , m_uri(item->uri()) {}

    virtual ~VideoImpl(void) {}

    Video* parent(void) const
    { return m_parent; }

    QString const& uri(void) const
    { return m_uri; }

    void end(void)
    { Q_EMIT parent()->end(); }

    virtual void pause(void) = 0;
    virtual void resume(void) = 0;
    virtual bool onTimeout(void) = 0;
    virtual bool start(void) = 0;
    virtual bool stop(void) = 0;

private:

    Video* m_parent;
    QString m_uri;
};

#endif // _BROWSER_WIDGETS_VIDEO_VIDEOIMPL_H_
