if(GTEST_FOUND AND BUILD_TEST)
  enable_testing()
  include_directories(${GTEST_INCLUDE_DIRS})
endif()

macro(ADD_TEST_DIRECTORY __dir_name)
  if (GTEST_FOUND AND BUILD_TEST)
    add_subdirectory("${__dir_name}")
  endif()
endmacro()

macro(CREATE_TEST __name __args)
  add_executable("test_${__name}" ${ARGN})
  get_property(test_location
    TARGET "test_${__name}"
    PROPERTY LOCATION)
  target_link_libraries("test_${__name}"
    ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread)
  gtest_add_tests("${test_location}" "${__args}" ${ARGN})
endmacro()
