#include <QDebug>
#include <QFile>
#include <QProcess>
#include <QObject>
#include "maintenance.h"

Maintenance::Maintenance(QObject *parent):
    QObject(parent)
{

#ifdef __arm__
    m_deskPath = "/home/pi/Desktop/";
    m_dataDir = "/home/pi/.linutop-kiosk/data/";
#else
    m_deskPath = "/home/linutop/Desktop/";
    m_dataDir = "/home/linutop/.linutop-kiosk/data/";
#endif
}

void Maintenance::startMaintenance(QString filename)
{
    qDebug() << filename.mid(7);
    m_unzip = new QProcess;
    QStringList args;
    args << "-o" << filename.mid(7) << "-d" << m_deskPath;
    m_unzip->start("unzip", args);

    QObject::connect(m_unzip, SIGNAL(finished(int)), this, SLOT(launchScript()));
    //QObject::connect(m_unzip, SIGNAL(readyReadStandardOutput()), this, SLOT(readyread()));
    //QObject::connect(m_unzip, SIGNAL(readyReadStandardError()), this, SLOT(readyread()));
    m_unzip->waitForFinished();
    m_unzip->deleteLater();
}

void Maintenance::readyread()
{
    qDebug() << m_cmd->readAllStandardOutput();
    qDebug() << m_cmd->readAllStandardError();
}

void Maintenance::launchScript()
{
    m_cmd = new QProcess;
    m_cmd->start("sh", QStringList() << m_deskPath + "maintenance_linutop-kiosk.sh");
    //m_cmd->start("sudo", QStringList() << "apt-get" << "update");
    //QObject::connect(m_cmd, SIGNAL(finished(int)), this, SLOT(reboot()));
    //QObject::connect(m_cmd, SIGNAL(readyReadStandardOutput()), this, SLOT(readyread()));
    m_cmd->waitForFinished();
    m_cmd->deleteLater();
}

void Maintenance::reboot()
{

    QFile file(m_dataDir+"/maintenance.txt");
    if(file.open(QIODevice::WriteOnly))
    {
        file.resize(0);
        file.write("Update succeed!");
    }
    m_reboot = new QProcess;
    m_reboot->start("sudo", QStringList() << "reboot" << "now");
}
