#ifndef PROXYFACTORY_H
#define PROXYFACTORY_H

#include <QNetworkProxyFactory>
#include <QNetworkProxy>
#include <QUrl>

#include <proxy.h>

#include "runnable.h"
#include "settings.h"


class CommandLineParser;
class ProxyFactory : public QNetworkProxyFactory
{
public:
    ProxyFactory(CommandLineParser const* cmdparse);
    ~ProxyFactory();

    QList<QNetworkProxy> queryProxy(const QNetworkProxyQuery &query = QNetworkProxyQuery());

private:
    Settings *settings;
    int proxyType;
    pxProxyFactory *pf;
    QString proxyUser;
    QString proxyPasswd;
    QUrl proxyUri;

};

#endif
