# -*- coding: utf-8 -*-
__author__ = 'Most Wanted'
import logging


class LoggingPlugin(object):
    """
    Allows to write log for bottle applications
    """
    name = 'logging_plugin'
    api = 2

    def __init__(self):
        #todo: add stream and format parameters
        self.app = None
        self.logger = None

    def setup(self, app):
        self.app = app
        logger = logging.getLogger(__name__)
        logger.setLevel(logging.DEBUG)
        formatter = logging.Formatter('%(module)s (%(lineno)d):%(asctime)s:[%(levelname)s] %(message)s')
        formatter.datefmt = '%d/%m/%y %H:%M'
        handler = logging.StreamHandler()
        handler.setFormatter(formatter)
        logger.addHandler(handler)
        self.logger = logger
        self.log = self.logger.log
        self.app.log = self.logger.log
        self.critical = self.logger.critical
        self.error    = self.logger.error
        self.warning  = self.logger.warning
        self.info     = self.logger.info
        self.debug    = self.logger.debug

logger = LoggingPlugin()