function updatePlaylist()
{
	$.get("/remote/playlist", function(data)
	{
		data = $.parseJSON(data);
		$("#remote li").remove();
		if (data.remote)
		{
			$.each($("item", data.playlist), function(index, item)
			{
				makeItem(item);
			});
		}
		else
		{
			$.each(data.playlist, function(index, item) { makeItem(item,index); });
		}
	});
}

function makeChannel(label, screenPath)
{
	$("<li class='list-group-item btn'></li>")
			.html(label)
			.click(function()
			{
				var current = $(this)[0];
				setTimeout(function()
				{
					current.classList.remove("active");
				}, 400);
				current.classList.add("active");
				$.post("/remote/start", { 'screen': screenPath });
			})
			.appendTo("#channels .list-group-channels");
}

function deleteItem(name)
{
  	$.post("/dragndrop/delete/" + name);
  	setTimeout(updatePlaylist, 400);
 }

function makeItem(item, index)
{
	var name = item.name || item.attributes['name'].value || "no_name";
	if (item.deletable) name = name + ' <img onclick=deleteItem("' + name + '") src="static/delete_icon.png"/>';
	$("<li class='list-group-item btn'></li>")
		.html(name).appendTo("#remote .list-group")
		.click(function()
		{
			var current = $(this)[0];
			setTimeout(function()
			{
				current.classList.remove("active");
			}, 400);
			current.classList.add("active");

			$.post("/remote/goto",
			{
				'index': index == null ? $(item).index() : index,
				'loop' : $(item).parent().attr("id") || 0
			});
		});
}

function updateChannels(q)
{
	$("#channels .list-group-channels").find("li").remove();
	$.get("/remote/channels", { q : q }, function(data)
	{
		data = $.parseJSON(data);
		var screens = Array.isArray(data.data['screens']) ? data.data['screens'] : data.data;
		$.each(screens, function(index, sc)
		{
			var token = sc.token ? sc.token : "public";
			var path = sc.login + "-" + sc.screen + "/" + token;
			makeChannel(sc.label, path);
		});

		$.get("/remote/islocalplaylist", function(data)
		{
			if (JSON.parse(data).data)
				makeChannel("Local playlist","local");
		});

		$("#channels-nav .btn-prev").attr("disabled", "disabled");
		$("#channels-nav .btn-next").attr("disabled", "disabled");
		if (data.isPrev) $("#channels-nav .btn-prev").removeAttr("disabled");
		if (data.isNext) $("#channels-nav .btn-next").removeAttr("disabled");

		$("#channels-nav .invoice-label").text(data.invoice);

		if (!data.isNext && !data.isPrev)
			$("#channels-nav").hide();
	});
}

$(function()
{
	var lfe = new LocalFileExplorer();

	$.get("/info",function(data)
	{
		data = $.parseJSON(data);
		$("#url").html(data.url);
		$("#invoice").html(data.invoice);
	});

	$("#tabs a").click(function(event)
	{
		$(this).tab("show");
		$("#menu").collapse("hide");
	});

	$(document).on("show.bs.tab", function(event)
	{ $(event.target.dataset.target).trigger("show.linutop"); });

	$(document).on("shown.bs.tab", function(event)
	{ $(event.target.dataset.target).trigger("shown.linutop"); });

	$("#channels").on("show.linutop", function()
	{
		$("#channels-nav").show();
		updateChannels();
		lfe.createLocalFileBrowser();
	});

	$("#remote").on("show.linutop", function()
	{
		$("#channels-nav").hide();
		updatePlaylist();
	});

	$("#text").on("show.linutop",function () {
		$("#channels-nav").hide();
		$.post("/remote/screenShot");
		$(".glyphicon-time").removeClass("hidden");
		$(this).find("img").addClass("hidden");
	}).on("shown.linutop",function () {
		$(this).find("img").attr("src","/res/screen");
	}).find("img").on("load", function () {
		$(this).removeClass("hidden");
		$(".glyphicon-time").addClass("hidden");
	});

	$("#text").find("button").click(function (event) {
		$.post("/remote/text",$(this).parent().serialize());

		var that = $(this);
		var onclickSet = false;
		var reloadImage = function() {
			var r = Math.floor(Math.random()*(new Date()).getTime());
			$("#screen").remove();
			var image = $("<img>").attr("id","screen").addClass("img-responsive").attr("src","/res/screen?" + r).prependTo("#submit-text");
			if (!onclickSet) image.on("click", reloadImage);
		}
		setTimeout(reloadImage, 2000);
	});

	if(!window.location.hash){
		window.location.hash = "#channels";
	}

	if(window.location.pathname!="/text"){
		$("#tabs a").each(function(index, item){
			if(item.dataset.target == window.location.hash){
				$(item).click();
			}
		});
	}
	else{
		$("#tabs a").click();
	}

	$("#control-group a").click(function()
	{
		$.post("/control/" + $(this).attr("id"));
		var current = $(this)[0];
		setTimeout(function()
		{
			current.classList.remove("active");
		}, 400);
		current.classList.add("active");
	});

	$("#menu")
	.on("shown.bs.collapse",function ()
	{
		$(".navbar-toggle span").removeClass("glyphicon-chevron-down").addClass("glyphicon-chevron-up");
	})
	.on("hidden.bs.collapse",function ()
	{
		$(".navbar-toggle span").removeClass("glyphicon-chevron-up").addClass("glyphicon-chevron-down");
	});

	$("#channels-nav .btn-next").on('click', function()
	{
		updateChannels("next");
	})

	$("#channels-nav .btn-prev").on('click', function()
	{
		updateChannels("prev");
	})

	$("#restart").on('click', function()
	{
		$.post("/remote/restart");
	});
});