function LocalFileExplorer() {
    this.path = '/',
    this.container = $("#channels .list-group-fs");

    this.icons = {
        "image" : "picture",
        "video" : "film",
        "audio" : "music",
        "document" : "book"
    }

    this.getFileList = function(cb) {
        $.get("/remote/localfiles", { path : this.path }, function(data) {
            cb(JSON.parse(data));
        });
    }

    this.createEntry = function(file) {
        var icon = $("<span>");
        if (file.directory) {
            icon.attr("class", "glyphicon glyphicon-folder-open");
        } else {
            icon.attr("class", "glyphicon glyphicon-" + this.icons[file.type]);
        }

        var entry = $("<li>").attr("class", "list-group-item btn").html("&nbsp;" + file.name).prepend(icon);

        entry.on('click', (function(o)
        {
            var that = o;
            return function()
            {
                if (file.directory)
                    that.goTo(file.name);
                else
                {
                    that.launch([that.path, file.name].join('/'));

                    var current = entry[0];
                    setTimeout(function()
                    {
                        current.classList.remove("active");
                    }, 400);
                    current.classList.add("active");
                }
            };
        })(this));

        return entry;
    }

    this.createLocalFileBrowser = function() {
        this.container.empty();

        if (this.path !== '/') {
            this.container.append(this.createEntry({ name : '..' , directory : true }));
        }

        this.getFileList((function(o) {
            var that = o;
            return function(files) {
                for (var i = 0; i < files.length; ++i) {
                    that.container.append(that.createEntry(files[i]));
                }
            };
        })(this));
    };

    this.goTo = function(dirName) {
        if (dirName === '..') {
            this.path = this.path.split('/');
            this.path = this.path.slice(0, this.path.length - 1).join('/');
        } else {
            this.path = [this.path, dirName].join('/');
        }
        this.createLocalFileBrowser();
    },

    this.launch = function(filePath) {
        $.post("/remote/goto", { filePath : filePath });
    }
};