#ifndef COOKIESAVER_H
#define COOKIESAVER_H

#include <QNetworkCookie>
#include <QNetworkCookieJar>
#include <QDialog>
#include <QToolBar>
#include <QLineEdit>
#include <QWebView>
#include <QDialogButtonBox>
#include <QVBoxLayout>

class FakeCookieJar : public QNetworkCookieJar
{
    Q_OBJECT

public:
    FakeCookieJar() : QNetworkCookieJar() {}
    QList<QNetworkCookie> allCookies() const {
        return QNetworkCookieJar::allCookies();
    }
};

class CookieSaver : public QDialog
{
    Q_OBJECT

public:
    CookieSaver(QStringList *urls, QWidget *parent = 0);
    QList<QNetworkCookie> allCookies();

private slots:
    void show();
    void onPrevious();
    void onNext();
    void accept(void);

private:
    QStringList *m_urls;
    int m_idx;

    QToolBar m_navBar;
    QLineEdit m_addressEdit;
    QWebView m_webView;
    QDialogButtonBox m_buttonBox;
    QVBoxLayout m_layout;

    FakeCookieJar m_jar;
};

#endif
