#include <unistd.h>
#include <sys/types.h>

#include <QApplication>
#include <QMessageBox>
#include <QTranslator>

#include "settingsui.h"
#include "commandlineparser.h"

int main(int argc, char **argv)
{
    CommandLineParser cmdparse(argc, argv);
    if (cmdparse.needHelp())
    {
        cmdparse.displayHelp();
        return 0;
    }
    QApplication app(argc, argv);

    //QTextCodec::setCodecForCStrings(QTextCodec::codecForName("utf8"));
    QTranslator qtTranslator;
    qtTranslator.load("settings_" + QLocale::system().name(),
                      "/usr/share/linutop-webkiosk/i18n");
    app.installTranslator(&qtTranslator);

    if (geteuid() != 0)
    {
        QMessageBox::warning(
                    NULL, QObject::tr("Root Access Required"),
                    QObject::tr("You need to be root to "
                                "execute this application."));
        return 1;
    }

    SettingsDialog d(NULL, &cmdparse);
    d.show();

    return app.exec();
}

