#include <QPushButton>

#include "password.h"

PasswordDialog::PasswordDialog(QWidget *parent)
    : QDialog(parent)
{
    ui.setupUi(this);

    ui.buttonBox->button(QDialogButtonBox::Ok)->setEnabled(false);

    connect(ui.passwordEdit, SIGNAL(textChanged(const QString &)),
            this, SLOT(onPasswordChanged(const QString &)));
    connect(ui.repeatPasswordEdit, SIGNAL(textChanged(const QString &)),
            this, SLOT(onPasswordChanged(const QString &)));

    connect(ui.buttonBox->button(QDialogButtonBox::Ok), SIGNAL(clicked(bool)),
            this, SLOT(onValidated(bool)));
    connect(ui.buttonBox->button(QDialogButtonBox::Cancel),
            SIGNAL(clicked(bool)),
            this, SLOT(onCancelled(bool)));
}

void PasswordDialog::onPasswordChanged(const QString &value)
{
    QString p1 = ui.passwordEdit->text();
    QString p2 = ui.repeatPasswordEdit->text();

    if (p1.isEmpty() || p2.isEmpty() || p1 != p2)
        ui.buttonBox->button(QDialogButtonBox::Ok)->setEnabled(false);
    else
        ui.buttonBox->button(QDialogButtonBox::Ok)->setEnabled(true);
}

void PasswordDialog::onValidated(bool b)
{
    done(QDialog::Accepted);
}

void PasswordDialog::onCancelled(bool b)
{
    done(QDialog::Rejected);
}
