#include "spinboxdelegate.h"

QWidget *SpinBoxDelegate::createEditor(QWidget *parent,
        const QStyleOptionViewItem &option,
        const QModelIndex &index) const
{
    QSpinBox *editor = new QSpinBox(parent);
    editor->setMinimum(0);
    editor->setMaximum(100000);

    return editor;
}

void SpinBoxDelegate::setEditorData(QWidget *editor,
        const QModelIndex &index) const
{
    int value = index.model()->data(index, Qt::DisplayRole).toInt();
    static_cast<QSpinBox *>(editor)->setValue(value);
}

void SpinBoxDelegate::setModelData (QWidget *editor,
        QAbstractItemModel *model,
        const QModelIndex &index ) const
{
    QSpinBox *spinBox = static_cast<QSpinBox*>(editor);
    spinBox->interpretText();
    int value = spinBox->value();

    model->setData(index, value);
}

void SpinBoxDelegate::updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option,
        const QModelIndex &index) const
{
    editor->setGeometry(option.rect);
}

