#ifndef TREEVIEW_H
#define TREEVIEW_H

#include <QStandardItemModel>
#include <QTreeView>

#include "spinboxdelegate.h"

class TreeView : public QTreeView
{
    Q_OBJECT

public:
    TreeView(QWidget *parent = 0);
    void add(QString url, int duration);
    void delSelection();
    void moveSelection(int howMuch);
    bool isEmpty(){return m_model->rowCount()==0;}

private:
    QStandardItemModel *m_model;
    SpinBoxDelegate *m_delegate;

private slots:
    void onDataChanged(QModelIndex, QModelIndex);

signals:
    void dataChanged();
};

#endif
