import os
from xml.dom import minidom

d = os.path.dirname(os.path.realpath(__file__))
target = d + '/../common/mimedb.cpp'
xml = d + '/freedesktop.org.xml'

xmldoc = minidom.parse(xml)
dict = {}
for item in xmldoc.getElementsByTagName('mime-type'):
    for ex in item.getElementsByTagName('glob'):
        extension = ex.attributes['pattern'].value.split(".")[-1]
        if extension:
            dict[extension] = item.attributes['type'].value

with open(target, 'w') as f:
    f.write("""#include "mimedb.h"

QMap<QString, QString> MimeDb::map = init();

QString MimeDb::get(QString ext)
{
    if (map.contains(ext))
        return map[ext];
    else
        return QString();
};

QString MimeDb::getForFileName(QString filename)
{
    QStringList spl = filename.split(".");
    return MimeDb::get(spl.at(spl.size() - 1));
}

QMap<QString, QString> MimeDb::init() {
    QMap<QString, QString> map;

""")

    for tuple in dict.items():
        f.write('    map["%s"] = "%s";\n' % tuple)

    f.write("""
    return map;
}""")
